// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"tinyskin/db/ent/user"
	"tinyskin/db/ent/usertoken"
)

// UserTokenCreate is the builder for creating a UserToken entity.
type UserTokenCreate struct {
	config
	mutation *UserTokenMutation
	hooks    []Hook
}

// SetTokenID sets the "token_id" field.
func (utc *UserTokenCreate) SetTokenID(u uint64) *UserTokenCreate {
	utc.mutation.SetTokenID(u)
	return utc
}

// SetUserID sets the "user" edge to the User entity by ID.
func (utc *UserTokenCreate) SetUserID(id int) *UserTokenCreate {
	utc.mutation.SetUserID(id)
	return utc
}

// SetNillableUserID sets the "user" edge to the User entity by ID if the given value is not nil.
func (utc *UserTokenCreate) SetNillableUserID(id *int) *UserTokenCreate {
	if id != nil {
		utc = utc.SetUserID(*id)
	}
	return utc
}

// SetUser sets the "user" edge to the User entity.
func (utc *UserTokenCreate) SetUser(u *User) *UserTokenCreate {
	return utc.SetUserID(u.ID)
}

// Mutation returns the UserTokenMutation object of the builder.
func (utc *UserTokenCreate) Mutation() *UserTokenMutation {
	return utc.mutation
}

// Save creates the UserToken in the database.
func (utc *UserTokenCreate) Save(ctx context.Context) (*UserToken, error) {
	return withHooks(ctx, utc.sqlSave, utc.mutation, utc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (utc *UserTokenCreate) SaveX(ctx context.Context) *UserToken {
	v, err := utc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (utc *UserTokenCreate) Exec(ctx context.Context) error {
	_, err := utc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (utc *UserTokenCreate) ExecX(ctx context.Context) {
	if err := utc.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (utc *UserTokenCreate) check() error {
	if _, ok := utc.mutation.TokenID(); !ok {
		return &ValidationError{Name: "token_id", err: errors.New(`ent: missing required field "UserToken.token_id"`)}
	}
	return nil
}

func (utc *UserTokenCreate) sqlSave(ctx context.Context) (*UserToken, error) {
	if err := utc.check(); err != nil {
		return nil, err
	}
	_node, _spec := utc.createSpec()
	if err := sqlgraph.CreateNode(ctx, utc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	utc.mutation.id = &_node.ID
	utc.mutation.done = true
	return _node, nil
}

func (utc *UserTokenCreate) createSpec() (*UserToken, *sqlgraph.CreateSpec) {
	var (
		_node = &UserToken{config: utc.config}
		_spec = sqlgraph.NewCreateSpec(usertoken.Table, sqlgraph.NewFieldSpec(usertoken.FieldID, field.TypeInt))
	)
	if value, ok := utc.mutation.TokenID(); ok {
		_spec.SetField(usertoken.FieldTokenID, field.TypeUint64, value)
		_node.TokenID = value
	}
	if nodes := utc.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2O,
			Inverse: true,
			Table:   usertoken.UserTable,
			Columns: []string{usertoken.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(user.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.user_token = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// UserTokenCreateBulk is the builder for creating many UserToken entities in bulk.
type UserTokenCreateBulk struct {
	config
	builders []*UserTokenCreate
}

// Save creates the UserToken entities in the database.
func (utcb *UserTokenCreateBulk) Save(ctx context.Context) ([]*UserToken, error) {
	specs := make([]*sqlgraph.CreateSpec, len(utcb.builders))
	nodes := make([]*UserToken, len(utcb.builders))
	mutators := make([]Mutator, len(utcb.builders))
	for i := range utcb.builders {
		func(i int, root context.Context) {
			builder := utcb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*UserTokenMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, utcb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, utcb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, utcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (utcb *UserTokenCreateBulk) SaveX(ctx context.Context) []*UserToken {
	v, err := utcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (utcb *UserTokenCreateBulk) Exec(ctx context.Context) error {
	_, err := utcb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (utcb *UserTokenCreateBulk) ExecX(ctx context.Context) {
	if err := utcb.Exec(ctx); err != nil {
		panic(err)
	}
}
